#!/usr/bin/perl

# Index Finger v1.1
# Developed by Custom CGI - www.collegesucks.com
# Copyright 1998 Joseph Bannon - All rights reserved.

require 'config.cgi';
require 'variables/setup.cgi';
require 'programs.cgi';
require 'subroutes.cgi';

&parsequery;
    $action = $QUERY{'action'};
    $insiteid = $QUERY{'site'};

&parseform;
    $inrating = $FORM{'rating'};

    &mainmenuforpeople;

    # Check IP Address

    $surveyed = "no";
    $hostname = $ENV{'REMOTE_ADDR'};
    $ipfile = "log/log.cgi";

    if (-e $ipfile) {
        open(FILE, "$ipfile");
        flock(FILE,2);
        @lines = <FILE>;
        close(FILE);
        $voted = 0;
        foreach $line (@lines) {
            $line =~ s/\n//g;
            if($line eq "$hostname") { $surveyed = "yes"; }
            }
        }
    else {
        open(FILE,">$ipfile");
        close(FILE);
        }

    opendir (SITESDIR, "sites"); 
    @sitesdata = readdir(SITESDIR);
    closedir (SITESDIR);
    @sortedsitesdata = sort(@sitesdata);
    @sortedsitesdata = grep(/txt/,@sortedsitesdata);
    foreach $file (@sortedsitesdata) {
        ($important,$trash) = split (/\./,$file);
        ($groupid,$siteid,$timeadded,$status) = split (/\-/,$important);
        if ($siteid eq "$insiteid") {
            $filetoopen = "sites/$groupid-$siteid-$timeadded-$status.$trash";
            }
        }

    open(FILE,"$filetoopen");
    flock(FILE,2);
    @filedata = <FILE>;
    close(FILE);
    ($siteid,$groupid,$dateadded,$sitename,$siteurl,$sitedisc,$votes,$score) = split(/\|/,@filedata[0]);

if ($surveyed eq "no") {
    

    if (-e $filetoopen && $action ne "ratesite") {

        $output .= "<b>Rate A Site</b><p>\n";
        $output .= "$sitename<br>\n";
        $output .= "<font size=\"1\" color=\"#585858\">Current score of $score</font><p>\n";
        $output .= "<font size=\"2\" color=\"#000000\" face=\"verdana,arial\">\n";
        $output .= "<form action=\"$rateprogram?action=ratesite&site=$siteid\" method=post>\n";
        $output .= "How would you rate this site?\n";

        $output .= "<select name=\"rating\">\n";
        $output .= "<option value=\"0\" selected>0\n";
        $output .= "<option value=\"1\">1\n";
        $output .= "<option value=\"2\">2\n";
        $output .= "<option value=\"3\">3\n";
        $output .= "<option value=\"4\">4\n";
        $output .= "<option value=\"5\">5\n";
        $output .= "<option value=\"6\">6\n";
        $output .= "<option value=\"7\">7\n";
        $output .= "<option value=\"8\">8\n";
        $output .= "<option value=\"9\">9\n";
        $output .= "<option value=\"10\">10\n";
        $output .= "</select><p>\n";

        $output .= "0 is the lowest and 10 is the highest. Please try to be impartial. We also record your IP address, which means you can only rate one site.<p>\n";


        $output .= "<input type=\"submit\" value\"Submit Rating\"> \n";
        $output .= "<input type=\"reset\" value\"Reset\">\n";
        $output .= "\n";
        $output .= "</form>\n";
        }
    elsif (-e $filetoopen && $action eq "ratesite") {

        # Re-do score.
        $total = $votes * $score;
        $newtotal = $total + $inrating;
        $votes++;
        $newscore = $newtotal / $votes;
        $newscore = sprintf ("%2.2f",$newscore);

        open(FILE,">$filetoopen");
        flock(FILE,2);
        print FILE "$siteid|$groupid|$dateadded|$sitename|$siteurl|$sitedisc|$votes|$newscore";
        close(FILE);

        open(FILE,">>$ipfile");
        flock(FILE,2);
        print FILE "$hostname\n";
        close(FILE);


        $output .= "<b>Rating Submitted</b><p>\n";
        $output .= "<a href=\"$programurl/html/$groupid.html\">Return to from where you came</a>\n";




        }
    else {
        $output .= "<b>Rate A Site - Site Not Available</b><p>\n";
        $output .= "Please click the back button on your browser.\n";
        }

    }

else {
    $output .= "<b>You Have Already Rated A Site</b><p>\n";
    $output .= "<a href=\"$programurl/html/$groupid.html\">Return to from where you came</a>\n";
    }



    &poweredbyforpeople;
    &template;